<?php

class User
{
	// Имя пользователя.
	protected $name;
	
	// Возраст пользователя.
	protected $age;
	
	// Пол пользователя.
	protected $sex;

	// URL домашней страницы пользователя.
	protected $homepage_url;

	public function __construct(){}
	
	public function setName($name,$name2) {
		$name = trim($name);
		if ($name == '') {
			throw new Exception('Не указано имя пользователя');
		}
		$this->name = $name;
        $this->name2 = $name2;
		return $this;
	}
	
	public function getName() {
		return '<div class="change_block"><strong>'.$this->name2.'</strong> &nbsp;'.$this->name .'</div>';
	}
	
	public function setAge($age) {
		if (is_object($age) && $age instanceof Datetime) {
			$this->age = $age;
		} else {
			try {
				$age = new Datetime($age);
				$this->age = $age;
			} catch (Exception $e) {
				throw new Exception('Некорректный формат даты рождения пользователя');
			}
		}
		
		return $this;
	}
		public function getAge() {
		return $this->age;
	}
	
	 /*
	 * Определяет права пользователя
	*/
    public function user_rights($id,$change_view) {
	global $user_id;
	
	    //Вывод права в личных профилях пользователей
	    if($change_view == false) {
			if($id == 6){
	   		    echo '<b style="color:red;">Создатель</b>';
	 		}elseif($id == 4){
	            echo '<b>Администратор</b>';
            }elseif($id == 2){
	            echo '<b>Модератор</b>';
	        }elseif($id == 1){
	            echo '<b>Пользователь</b>';
	        }
		}else {
	        if($id == NULL) { $id = $user_id; }
	        if(isset($id)) {
	            $users = mysql_fetch_array(mysql_query("SELECT * FROM `users` WHERE `id` = '$id'"));}
				
	        if($users['team'] == 6 and $users['id'] == $id) {
	            echo '<span style="color:red;font-weight:700;">Создатель</span>';
	        }elseif($users['team'] == 4 and $users['id'] == $id) {
	            echo '<span style="color:red;font-weight:700;">Администратор</span>';
	        }elseif($users['team'] == 2 and $users['id'] == $id) {
	            echo '<span style="color:red;font-weight:700;">Модератор</span>';
	        }elseif($users['team'] == 1 and $users['id'] == $id) {
	            echo 'Пользователь';}
	    }
    }
	public function setSex($sex) {
		if (!in_array($sex, array('male', 'female'))) {
			throw new Exception('Неопределённый пол пользователя');
		}
		$this->sex = $sex;
		
		return $this;
	}
	
	public function getSex() {
		return $this->sex;
	}
	
	public function setHomepageUrl($url) {
		$this->homepage_url = $url;
		
		return $this;
	}
	
	public function getHomepageUrl() {
		return $this->homepage_url;
	}
}
?>